'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FooterStyles = require('./FooterStyles');

var _Help = require('../Help/Help');

var _Help2 = _interopRequireDefault(_Help);

var _media = require('../../theme/media');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Footer = function (_Component) {
	_inherits(Footer, _Component);

	function Footer(props) {
		_classCallCheck(this, Footer);

		var _this = _possibleConstructorReturn(this, (Footer.__proto__ || Object.getPrototypeOf(Footer)).call(this, props));

		_this.componentWillUnmount = function () {
			window.removeEventListener('resize', _this.smallHelp);
		};

		_this.smallHelp = function () {
			if (window.innerWidth <= _media.ScreenSizes.tablet) {
				_this.setState({ small: true });
			} else if (window.innerWidth > _media.ScreenSizes.tablet) {
				_this.setState({ small: false });
			}
		};

		_this.state = {
			small: false
		};
		return _this;
	}

	_createClass(Footer, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.smallHelp();
			window.addEventListener('resize', this.smallHelp);
		}
	}, {
		key: 'render',
		value: function render() {
			return !this.state.small ? _react2.default.createElement(
				_FooterStyles.StyledFooter,
				null,
				_react2.default.createElement(
					_FooterStyles.Link,
					{ href: this.props.labelLink ? this.props.labelLink : this.defaultProps.labelLink, target: this.props.target },
					_react2.default.createElement(
						'div',
						{ style: { display: 'flex', flexFlow: 'row nowrap', justifyContent: 'center', alignItems: 'center' } },
						this.props.label ? _react2.default.createElement(this.props.label, null) : _react2.default.createElement(this.defaultProps.label, null),
						' ',
						' \xA0 | ',
						this.props.helpID
					)
				),
				_react2.default.createElement(_Help2.default, { small: this.state.small, helpID: this.props.helpID, helpLabel: this.props.helpLabel })
			) : null;
		}
	}]);

	return Footer;
}(_react.Component);

Footer.propTypes = {
	label: _propTypes2.default.any,
	labelLink: _propTypes2.default.string,
	target: _propTypes2.default.string,
	debug: _propTypes2.default.string
};

Footer.defaultProps = {
	label: _react2.default.createElement(
		'div',
		null,
		_react2.default.createElement(
			'b',
			null,
			'ODEUM Code Lite '
		),
		' v1.0.0 \xA9 Copyright'
	),
	labelLink: '/',
	target: '',
	debug: ''

};

exports.default = Footer;