'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _MenuItem = require('./MenuComponents/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _MenuDiv = require('./MenuComponents/MenuDiv');

var _MenuDiv2 = _interopRequireDefault(_MenuDiv);

var _MenuStyles = require('./MenuStyles');

var _QuickNavigation = require('../QuickNavigation/QuickNavigation');

var _QuickNavigation2 = _interopRequireDefault(_QuickNavigation);

var _Functions = require('../utils/Functions');

var _media = require('../../theme/media');

var _NotFound = require('../AppContainer/NotFound');

var _NotFound2 = _interopRequireDefault(_NotFound);

var _Tab = require('../Tabs/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuPanel = function (_Component) {
	_inherits(MenuPanel, _Component);

	function MenuPanel(props) {
		_classCallCheck(this, MenuPanel);

		var _this = _possibleConstructorReturn(this, (MenuPanel.__proto__ || Object.getPrototypeOf(MenuPanel)).call(this, props));

		_this.componentWillMount = function () {
			_this.updateWindowSize();
			window.addEventListener('resize', _this.updateWindowSize);
		};

		_this.componentWillUnmount = function () {
			window.removeEventListener('resize', _this.updateWindowSize);
		};

		_this.updateWindowSize = function () {
			// console.log('MenuDiv', 'resized')s
			if (window.innerWidth < _media.ScreenSizes.tablet)
				//QuickNav on
				_this.setState({
					quicknav: true
				});
			if (window.innerWidth >= _media.ScreenSizes.tablet) _this.setState({
				quicknav: false
			});
		};

		_this.route = function (child) {
			return child.props.route ? child.props.route : (0, _Functions.convertLabelToRoute)(child.props.label);
		};

		_this.getFirstChildRoute = function (child) {
			var children = _react2.default.Children.toArray(child.props.children);
			if (children[0].type === _Tab2.default) {
				if (children[0].props.route !== undefined) return children[0].props.route;else {
					if (children[0].props.label) return (0, _Functions.convertLabelToRoute)(children[0].props.label);else return '';
				}
			} else return '';
		};

		_this.convertChildLabelToRoute = function (child, many) {
			var route = '';
			var children = _react2.default.Children.toArray(child.props.children);
			if (children[0].props.label) route = (0, _Functions.convertLabelToRoute)(children[0].props.label);
			return route;
		};

		_this.switch = function (bool) {
			return _this.setState({ quicknav: bool });
		};

		_this.setActiveMenu = function (key) {
			// console.log('ActiveMenu', key)
			_this.setState({ activeMenu: key });
		};

		_this.renderChild = function (child, index) {
			return function (_ref) {
				var match = _ref.match;
				return _react2.default.cloneElement(child, { quicknav: _this.state.quicknav, setActiveMenu: _this.setActiveMenu, index: index, activeMenu: _this.state.activeMenu, route: _this.route(child) });
			};
		};

		_this.renderMenu = function (children) {
			return _react2.default.createElement(
				_MenuStyles.MenuContainer,
				{ quicknav: _this.state.quicknav },
				!_this.state.quicknav ? _react2.default.createElement(
					_MenuDiv2.default,
					{ quicknav: _this.switch },
					children.map(function (child, index) {
						return child.props.label ? _react2.default.createElement(_MenuItem2.default, { key: index,
							setHelpID: _this.props.SetHelpID,
							MenuID: index,
							helpID: child.props.helpID,
							active: _this.state.activeMenu === index ? true : false,
							icon: child.props.icon,
							label: child.props.label,
							route: _this.route(child) + _this.getFirstChildRoute(child),
							onClick: _this.setActiveMenu }) : null;
					})
				) : _react2.default.createElement(_QuickNavigation2.default, { menus: children }),
				_react2.default.createElement(
					_reactRouterDom.Switch,
					null,
					children.map(function (child, i) {
						return _react2.default.createElement(_reactRouterDom.Route, { key: i, path: _this.route(child), exact: (0, _Functions.isExact)(_this.route(child)), route: _this.route(child), component: _this.renderChild(child, i) });
					}),
					_react2.default.createElement(_reactRouterDom.Route, { path: '*', component: _NotFound2.default })
				)
			);
		};

		_this.state = {
			quicknav: false,
			disableMenuAchordeon: false,
			activeMenu: 0
		};
		return _this;
	}

	//#region Display quickNav or Menu 

	//#endregion 


	//#region Routing + Get First Child Route 

	//#endregion

	//#region State Management

	//#endregion

	//#region Rendering

	_createClass(MenuPanel, [{
		key: 'render',
		value: function render() {
			return this.renderMenu(_react2.default.Children.toArray(this.props.children));
		}

		//#endregion

	}]);

	return MenuPanel;
}(_react.Component);

exports.default = MenuPanel;