'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _QuickNavigationStyles = require('./QuickNavigationStyles');

var _Tab = require('../Tabs/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _Functions = require('../utils/Functions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import { NavLink } from 'react-router-dom'


//TODO:
//7. Active Menu Item, Active Tab Item

var QuickNavigation = function (_Component) {
	_inherits(QuickNavigation, _Component);

	function QuickNavigation(props) {
		_classCallCheck(this, QuickNavigation);

		var _this = _possibleConstructorReturn(this, (QuickNavigation.__proto__ || Object.getPrototypeOf(QuickNavigation)).call(this, props));

		_this.tabClick = function () {
			_this.setState({ quickNav: false });
		};

		_this.menuClick = function () {
			return function (e) {
				e.stopPropagation();
			};
		};

		_this.setActiveMenu = function (index) {
			return function (e) {
				e.preventDefault();
				e.stopPropagation();
				_this.setState({ activeMenu: index });
			};
		};

		_this.openNav = function () {
			_this.setState({ quickNav: !_this.state.quickNav });
		};

		_this.renderMenuItem = function (menu, index) {
			var route = menu.props.route ? menu.props.route : (0, _Functions.convertLabelToRoute)(menu.props.label);
			if (_react2.default.Children.toArray(menu.props.children)[0].type === _Tab2.default) return _react2.default.createElement(
				_QuickNavigationStyles.MenuItem,
				{ key: index, onClick: _this.setActiveMenu(index) },
				menu.props.label
			);else return _react2.default.createElement(
				_QuickNavigationStyles.MenuItem,
				{ key: index, onClick: _this.setActiveMenu(index) },
				_react2.default.createElement(
					_QuickNavigationStyles.Link,
					{ to: route },
					menu.props.label
				)
			);
		};

		_this.renderTabItem = function (tab, menu, index) {
			var menuRoute = menu.props.route ? menu.props.route : (0, _Functions.convertLabelToRoute)(menu.props.label);
			var route = tab.props.route ? menuRoute + tab.props.route : menuRoute + (0, _Functions.convertLabelToRoute)(tab.props.label);
			return _react2.default.createElement(
				_QuickNavigationStyles.TabItem,
				{ key: index, to: route, onClick: _this.tabClick },
				tab.props.label ? tab.props.label : tab.props.route
			);
		};

		_this.state = {
			quickNav: false,
			showButton: true,
			activeMenu: 0
		};
		return _this;
	}

	_createClass(QuickNavigation, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			// console.log(this.props)
			var quickNav = this.state.quickNav;

			return _react2.default.createElement(
				_QuickNavigationStyles.QuickNav,
				null,
				_react2.default.createElement(
					_QuickNavigationStyles.QuickNavButton,
					{ onClick: this.openNav },
					'Quick Navigation'
				),
				_react2.default.createElement(
					_QuickNavigationStyles.QuickNavContainer,
					{ quickNav: quickNav, onClick: this.openNav },
					_react2.default.createElement(
						_QuickNavigationStyles.QuickNavMenu,
						{ onClick: this.menuClick() },
						_react2.default.createElement(
							'button',
							{ onClick: this.openNav },
							'X'
						),
						_react2.default.createElement(_QuickNavigationStyles.Spacer, null),
						_react2.default.createElement(
							_QuickNavigationStyles.TabList,
							null,
							_react2.default.Children.toArray(this.props.menus[this.state.activeMenu].props.children).map(function (tab, index) {
								return tab.type === _Tab2.default ? _this2.renderTabItem(tab, _this2.props.menus[_this2.state.activeMenu], index) : undefined;
							})
						),
						_react2.default.createElement(_QuickNavigationStyles.Spacer, null),
						_react2.default.createElement(
							_QuickNavigationStyles.MenuList,
							null,
							_react2.default.Children.toArray(this.props.menus).map(function (menu, index) {
								return _this2.renderMenuItem(menu, index);
							})
						)
					)
				)
			);
		}
	}]);

	return QuickNavigation;
}(_react.Component);

exports.default = QuickNavigation;